/*
 * HTTPSensor / Actor
 * v.0.2 vom 18.10.2018
 * M.Sc.
 * 
 * Benutzung auf eigene gefahr.
 */

/*### INCLUDES ### */
#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>             
#include <FS.h>                           
#include <ArduinoJson.h>
//#include <Arduino.h>
#include <oled.h>
#include <DallasTemperature.h>
#include <OneWire.h>
#include <WiFiManager.h>
#include <DNSServer.h> 

#define ONE_WIRE_BUS D3

ESP8266WebServer server(80);

WiFiManager wifiManager;

OLED display=OLED(4,5,16);

OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature DS18B20(&oneWire);

//char ssid[20] = "";
//char password[40] = "";

char sensorhost[16] = "255.255.255.255";
char sensorport[6] = "5000";

boolean testRelaisOn = false;

IPAddress ip;

void setup() {
  Serial.begin(115200);

  display.begin();   

  DS18B20.begin();
  
  displayBootscreen("Mounting Filesystem");  
  if (!SPIFFS.begin())  { displayBootscreen("SPIFFS Mount failed"); delay(2000); } 

  displayBootscreen("Loading Config File");
  loadConfig();

  WiFiManagerParameter cstm_sensorhost("host", "cbpi ip", sensorhost, 15);
  WiFiManagerParameter cstm_sensorport("port", "cbpi port", sensorport, 6);

  wifiManager.setSaveConfigCallback(saveConfigCallback);
  wifiManager.addParameter(&cstm_sensorhost);
  wifiManager.addParameter(&cstm_sensorport);

  displayBootscreen("Startin WiFi. Please connect to AP");
  wifiManager.autoConnect("HTTPActSens");

  strcpy(sensorhost, cstm_sensorhost.getValue());
  strcpy(sensorport, cstm_sensorport.getValue());

  displayBootscreen("Saving Config");
  saveConfig();
  
  //displayBootscreen("Starting WiFi");  
  //startWifi();

  displayBootscreen("Starting Webserver");  
  setupServer();  

  displayMain();   
}

void loop() {

  if (WiFi.status() != WL_CONNECTED) {  wifiManager.autoConnect("HTTPActSens"); }
  
  server.handleClient();

  handleSensors();
}
