//void startWifi() {  
//  WiFi.begin(ssid, password);
  
//  while (WiFi.status() != WL_CONNECTED) {
//    delay(500);
//  }
  
//}

void setupServer() {
  
  server.on("/",handleRoot);
  
  server.on("/setupActor",handleSetActor);      // Einstellen der Aktoren
  server.on("/setupSensor",handleSetSensor);    // Einstellen der Sensoren
  
  server.on("/actors",handleActors);            // Aktor schalten
  server.on("/sensors",handleSensors);          // Sensor abfragen


  server.on("/reqSensors",handleRequestSensors);
  server.on("/reqActors",handleRequestActors);

  server.on("/reqSensor",handleRequestSensor);
  server.on("/reqActor",handleRequestActor);

  server.on("/setSensor",handleSetSensor);
  server.on("/setActor",handleSetActor);

  server.on("/delSensor",handleDelSensor);
  server.on("/delActor",handleDelActor);

    
  server.onNotFound(handleWebRequests);         // Sonstiges
  server.begin();
}

void handleRoot(){
  server.sendHeader("Location", "/index.html",true);   //Redirect to our html web page
  server.send(302, "text/plane","");
}

void handleWebRequests(){
  if(loadFromSpiffs(server.uri())) { return; }
  String message = "File Not Detected\n\n";
  message += "URI: ";
  message += server.uri();
  message += "\nMethod: ";
  message += (server.method() == HTTP_GET)?"GET":"POST";
  message += "\nArguments: ";
  message += server.args();
  message += "\n";
  for (uint8_t i=0; i<server.args(); i++){
    message += " NAME:"+server.argName(i) + "\n VALUE:" + server.arg(i) + "\n";
  }
  server.send(404, "text/plain", message);
}

bool loadFromSpiffs(String path){
  String dataType = "text/plain";
  if(path.endsWith("/")) path += "index.htm";

  if(path.endsWith(".src")) path = path.substring(0, path.lastIndexOf("."));
  else if(path.endsWith(".html")) dataType = "text/html";
  else if(path.endsWith(".htm")) dataType = "text/html";
  else if(path.endsWith(".css")) dataType = "text/css";
  else if(path.endsWith(".js")) dataType = "application/javascript";
  else if(path.endsWith(".png")) dataType = "image/png";
  else if(path.endsWith(".gif")) dataType = "image/gif";
  else if(path.endsWith(".jpg")) dataType = "image/jpeg";
  else if(path.endsWith(".ico")) dataType = "image/x-icon";
  else if(path.endsWith(".xml")) dataType = "text/xml";
  else if(path.endsWith(".pdf")) dataType = "application/pdf";
  else if(path.endsWith(".zip")) dataType = "application/zip";
  
  File dataFile = SPIFFS.open(path.c_str(), "r");
  if (server.hasArg("download")) dataType = "application/octet-stream";
  if (server.streamFile(dataFile, dataType) != dataFile.size()) {}

  dataFile.close();
  return true;
}
