class Actor
{
    String script_actor_on;
    String script_actor_off;

  public:
    byte pin_actor;      // the number of the LED pin
    String argument_actor;
    String name_actor;
  
  Actor(String pin, String argument, String aname) 
    { 
      pin_actor = getPIN(pin);
      pinMode(pin_actor,OUTPUT);
      digitalWrite(pin_actor,HIGH);
      argument_actor = argument;
      script_actor_on = "ON";
      script_actor_off = "OFF";
      name_actor = aname;
    }
  bool isOn;

  void change(String pin, String argument, String aname) {
    digitalWrite(pin_actor,HIGH);
    delay(5);
    pin_actor = getPIN(pin);
    pinMode(pin_actor,OUTPUT);
    digitalWrite(pin_actor,HIGH);
    isOn = false;
    name_actor = aname;    
    argument_actor = argument;
  }
    
  bool isCalled() {
    int numberOfArgs = server.args();
    
    for (int i = 0; i < numberOfArgs; i++) {
      if (server.argName(i) == argument_actor) {
         if (server.arg(i) == script_actor_on) {
          digitalWrite(pin_actor,LOW);
          isOn = true;        
          return true;
         }
         if (server.arg(i) == script_actor_off) {
          digitalWrite(pin_actor,HIGH);
          isOn = false;    
          return true;    
         }          
            
      }
      yield();
    }
    return false;
  }

  int getPIN(String pin) {
      if (pin == "D0") { return D0; }
      if (pin == "D4") { return D4; }
      if (pin == "D5") { return D5; }
      if (pin == "D6") { return D6; }
      if (pin == "D7") { return D7; }
      if (pin == "D8") { return D8; }
      return 99;                 
  }

  String getPinStr() {
      if (pin_actor == D0) { return "D0"; }
      if (pin_actor == D4) { return "D4"; }
      if (pin_actor == D5) { return "D5"; }
      if (pin_actor == D6) { return "D6"; }
      if (pin_actor == D7) { return "D7"; }
      if (pin_actor == D8) { return "D8"; }
      return "NaN";                 
  }  
};

Actor actors[6] = {
  Actor("","",""),
  Actor("","",""),
  Actor("","",""),
  Actor("","",""),
  Actor("","",""),
  Actor("","","")
  }; 
  
int numberOfActors;

void handleActors() {
  for (int i = 0; i < numberOfActors; i++) {
    if (actors[i].isCalled()) { displayMain(); }
  }
}  

void handleRequestActors() {
  String message;
                // actors?D0=</span> <a href="" class="badge badge-warning" data-toggle="modal" data-target="#actor_modal" data-value="0">Edit</a></li>
  for (int i = 0; i < numberOfActors; i++) {
    message += F("<li class=\"list-group-item d-flex justify-content-between align-items-center\">");
    message += actors[i].name_actor;
    message += F("</span> <span class=\"badge ");
    if (actors[i].isOn) {
      message += F("badge-success\">ON");
    } else {
      message += F("badge-dark\">OFF");
    }
    message += F("</span><span class=\"badge badge-light\">/actors?");
    message += actors[i].argument_actor;
    message += F("=</span> <span class=\"badge badge-light\">PIN ");
    message += actors[i].getPinStr();
    message += F("</span> <a href=\"\" class=\"badge badge-warning\" data-toggle=\"modal\" data-target=\"#actor_modal\" data-value=\"");
    message += i;
    message += F("\">Edit</a></li>");
    yield();
  }
  message += F("<li class=\"list-group-item justify-content-between align-items-center d-flex flex-row-reverse\"> <a href=\"\" class=\"badge badge-warning\" data-target=\"#actor_modal\" data-toggle=\"modal\" data-value=\"-1\">Add</a></li>");
  server.send(200,"text/html", message);
}

void handleRequestActor() {
  int id = server.arg(0).toInt();
  String request = server.arg(1);
  String message;

  if (id == -1) {
    message = "";
    goto SendMessage;  
  } else {
    if (request == "name") { message = actors[id].name_actor; goto SendMessage; }
    if (request == "script") { message = actors[id].argument_actor; goto SendMessage; }
    if (request == "pin") { message = actors[id].getPinStr(); goto SendMessage; }
    message = "not found";    
  }
  saveConfig();
  SendMessage:
    server.send(200,"text/plain",message);    
}

void handleSetActor() {
  int id = server.arg(0).toInt();
  
  if (id == -1) {
    Serial.println("New Actor");
    id = numberOfActors;
    numberOfActors += 1;            
  }

  String ac_pin = actors[id].getPinStr();
  String ac_argument = actors[id].argument_actor;
  String ac_name = actors[id].name_actor;

  Serial.println("Setting Actor.");
  Serial.print("ID is: ");
  Serial.println(id);

  for (int i = 0; i < server.args(); i++) {
    Serial.print("Argument Nr.");
    Serial.print(i);
    Serial.print(": Name = ");
    Serial.print(server.argName(i));
    Serial.print(", Argument =");
    Serial.println(server.arg(i));
    
    if (server.argName(i) == "name") { ac_name = server.arg(i); }  
    if (server.argName(i) == "pin")  { ac_pin = server.arg(i); }  
    if (server.argName(i) == "script")  { ac_argument = server.arg(i); }
    yield();       
  }

  actors[id].change(ac_pin,ac_argument,ac_name);
  
  saveConfig();
}

void handleDelActor() {
  int id = server.arg(0).toInt();

   for (int i = id; i < numberOfActors; i++) {
    if (i == 5) { actors[i].change("","",""); } else {
      actors[i].change(actors[i+1].getPinStr(),actors[i+1].argument_actor,actors[i+1].name_actor);     
    }
   }
  
  numberOfActors -= 1;
  saveConfig();
}
