class OneWireSensor
{    
  const char* script_prefix = "/api/httpsensor/"; 
  unsigned long lastCalled;
  long period = 5000;

  public:
  char script_sensor[50];
  byte index_sensor;  
  String name_sensor;
  
  OneWireSensor(byte index, String script, String sname) { 
    script.toCharArray(script_sensor,script.length()+1);
    index_sensor = index;
    name_sensor = sname;
    }
  float Value;
  
 
  void Update() {

    if (millis() > (lastCalled + period)) {  
      DS18B20.requestTemperatures();
      Value = DS18B20.getTempCByIndex(index_sensor);

      WiFiClient client;
      client.connect(sensorhost, atoi(sensorport));
      client.print(String("GET ") + script_prefix + script_sensor + "/" + getValueString() + " HTTP/1.1\r\n" +
      "Host: " + sensorhost + "\r\n" + 
      "Connection: close\r\n\r\n");     

      lastCalled = millis();
      Serial.println(script_sensor);
      displayMain();        
     }     
  }

  void change(int index, String script, String sname) {
    index_sensor = index;
    script.toCharArray(script_sensor,script.length()+1);
    name_sensor = sname;
  }
  
  char* getValueString() {
   char buf[5];
   dtostrf(Value,2,1,buf);
   return buf;
   }
  
};


OneWireSensor sensors[10] = {
  OneWireSensor(0,"",""),
  OneWireSensor(0,"",""),
  OneWireSensor(0,"",""),
  OneWireSensor(0,"",""),
  OneWireSensor(0,"",""),
  OneWireSensor(0,"",""),
  OneWireSensor(0,"",""),
  OneWireSensor(0,"",""),
  OneWireSensor(0,"",""),
  OneWireSensor(0,"","")
  };
int numberOfSensors;   
  

void handleSensors() {
    for (int i = 0; i < numberOfSensors; i++) {
      sensors[i].Update();
      yield();
  }
}

void handleRequestSensors() {
  String message;
  for (int i = 0; i < numberOfSensors; i++) {
    message += F("<li class=\"list-group-item d-flex justify-content-between align-items-center\">");
    message += sensors[i].name_sensor;
    message += F("<span class=\"badge badge-light\">");
    message += sensors[i].getValueString(); 
    message += F("&deg;C</span><span class=\"badge badge-info\">/api/httpsensor/");    
    message += sensors[i].script_sensor;
    message += F("</span> <a href=\"\" class=\"badge badge-warning\" data-toggle=\"modal\" data-target=\"#sensor_modal\" data-value=\"");
    message += i;
    message += F("\">Edit</a> </li>");
    Serial.print("Sending Sensor:");
    Serial.println(sensors[i].script_sensor);   
    yield();
  }
  message += F("<li class=\"list-group-item justify-content-between align-items-center d-flex flex-row-reverse\"> <a href=\"\" class=\"badge badge-warning\" data-toggle=\"modal\" data-target=\"#sensor_modal\" data-value=\"-1\">Add</a></li>");
  server.send(200,"text/html", message);
}

void handleRequestSensor() {
  int id = server.arg(0).toInt();
  String request = server.arg(1);
  String message;

  if (id == -1) {
    message = "";
    goto SendMessage;  
  } else {
    if (request == "name") { message = sensors[id].name_sensor; goto SendMessage; }
    if (request == "script") { message = sensors[id].script_sensor; goto SendMessage; }
    message = "not found";    
  }
  saveConfig();
  SendMessage:
    server.send(200,"text/plain",message); 
}
//
//
//void handleSearchSensors() {
//  int id = server.arg(0).toInt();
//  byte i;
//  byte present = 0;
//  byte data[12];
//  byte addr[8];
//  String message;
//  //<a class="dropdown-item" href="#">Action</a>
//
//  
//  while(oneWire.search(addr)) {
//   if ( OneWire::crc8( addr, 7) == addr[7]) { 
//    message += F("<option value=\"");
//    message += present;
//    message += F("\">");
//    for( i = 0; i < 8; i++) {
//      //message += ("0x");
//      if (addr[i] < 16) {
//        message += "0";
//      }
//      char txtbuf[20];
//      sprintf( txtbuf, "%x", addr[i]);
//      message += txtbuf;
//      if (i == 0) {
//        message += "-";
//      }
//      sensorsFound[present][i] = addr[i];
//      yield();
//    }
//     message += F("</option>");
//     present += 1;
//   }
//   yield();
//  }
//  
//  server.send(200,"text/html", message);
//  oneWire.reset_search();
//  return;
//  
//}

void handleSetSensor() {
  int id = server.arg(0).toInt();
  
  if (id == -1) {
    id = numberOfSensors;
    numberOfSensors += 1;            
  }

  String sens_script = sensors[id].script_sensor;
  String sens_name = sensors[id].name_sensor;


  for (int i = 0; i < server.args(); i++) {
    
    if (server.argName(i) == "name") { sens_name = server.arg(i); }  
    if (server.argName(i) == "script")  { sens_script = server.arg(i); }
    yield();       
  }

  sensors[id].change(id,sens_script,sens_name);
  
  saveConfig();
}

void handleDelSensor() {
  int id = server.arg(0).toInt();

   for (int i = id; i < numberOfSensors; i++) {
    if (i == 9) { sensors[i].change(0,"",""); } else {
      sensors[i].change(sensors[i+1].index_sensor,sensors[i+1].script_sensor,sensors[i+1].name_sensor);     
    }
   }
  
  numberOfSensors -= 1;
  saveConfig();
}
